﻿using Microsoft.SqlServer.Server;
using Prism.Mvvm;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Sockets;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using Toolkit.Log4;
using Toolkit.Tcp;
using Toolkit.View;
using static Toolkit.Tcp.TCPServer;

namespace Toolkit.ViewMode
{
    public class TcpWriteViewMode : ToolBase.ToolBase
    {

        private string data = "0";
        private string res = "0";

        public string Data { get => data; set { SetProperty(ref data, value); } }

        public string Res_write
        {
            get => res;
            set
            {
                SetProperty(ref res, value);

            }
        }



        public TCPClient client = new TCPClient();

        Task task;
        public TcpWriteViewMode()
        {
            int a = 0;
            
        }
        public bool SendMsg(TcpTriggerViewMode tcpTrigger)
        {
          
            try
            {
                BackgroundColor = Brushes.White;
                string data = MsgSplit(this.Tdata);
                this.Data =data;
                if (data != "Err")
                {

                    string str;
                   
                    str = client.SendLinux(data);
                    LogHelper.Info(str);
                    // str = client.ReceiveVarData(client.socket);

                    bool isagain=true;
                    while (true)
                    {
                        str = client.ReceiveVarData(client.socket);

                        if (str != "未收到数据" && str != "未连接")
                        {

                            if (str == "*T#")
                            {
                                isagain = true;
                                LogHelper.Info(str);
                                break;
                            }
                        }
                        if ( str == "未连接" ) 
                        {
                            LogHelper.Info(str);
                            tcpTrigger.TcpServerStop();
                            return false;
                        }
                        if ( str == "未收到数据"&& !isagain ) 
                        {
                            isagain = false;
                            LogHelper.Info(str);
                            SendNg();
                            return false;
                        }
                    }
                    while (true)
                    {
                        str = client.ReceiveVarData(client.socket);

                        if (str != "未收到数据" && str != "未连接")
                        {

                            if (str == "*P#")
                            {
                                isagain = true;
                                LogHelper.Info(str);
                                break;
                            }
                        }
                        if ( str == "未连接" )
                        {
                            tcpTrigger.TcpServerStop();
                            return false;
                        }
                        if ( str == "未收到数据" )
                        {
                            if ( tcpTrigger.SendStrs.Count > 1 )
                            {
                                return true;
                            }
                        }
                    }

                    SendNetCmd(client.socket,"25");
                    while ( true )
                    {
                        str = client.ReceiveVarData(client.socket);

                        if ( str != "未收到数据" && str != "未连接" )
                        {

                            if ( str == "fun" )
                            {
                                isagain = true;
                                LogHelper.Info(str);
                                break;
                            }
                        }

                        if ( str == "未连接" )
                        {
                            tcpTrigger.TcpServerStop();
                            return false;
                        }
                        if ( str == "未收到数据" && !isagain )
                        {
                            isagain = false;
                            LogHelper.Info(str);
                            SendNg();
                            return false;
                        }
                    }

                    while ( true )
                    {
                        str = client.ReceiveVarData(client.socket);

                        if ( str != "未收到数据" && str != "未连接" )
                        {

                            if ( str == "25" )
                            {
                                isagain = true;
                                LogHelper.Info(str);
                                break;
                            }
                        }
                        if ( str == "未连接" )
                        {
                            tcpTrigger.TcpServerStop();
                            return false;
                        }
                        if ( str == "未收到数据" && !isagain )
                        {
                            isagain = false;
                            LogHelper.Info(str);
                            SendNg();
                            return false;
                        }
                    }
                    int again=0;
                    while ( true )
                    {
                        str = client.ReceiveVarData(client.socket);

                        if ( str != "未收到数据" && str != "未连接" )
                        {

                            if ( str .Contains( "OKhp") )
                            {
                                isagain = true;
                                string []strs=str.Split(',');
                                PlcMsg plcMsg = new PlcMsg();
                                if ( strs[ 4 ] == "0" )
                                {
                                    plcMsg.printer = "0";
                                }
                                else 
                                {
                                    plcMsg.printer = "1";
                                }
                                if ( strs[ 5 ] == "0" )
                                {
                                    Thread.Sleep(1000);
                                    SendNetCmd(client.socket, "25");
                                    again++;
                                    if ( again < 3 )
                                    {
                                        continue;
                                    }
                                    plcMsg.printer = "1";
                                }
                                else
                                {
                                    plcMsg.printer = "0";
                                }
                                int ribbon=Convert.ToInt32(strs[ 29 ]);
                                if ( ribbon > 30 )
                                {
                                    plcMsg.ribbon = "0";
                                }
                                if ( ribbon < 30 )
                                {
                                    plcMsg.ribbon = "2";
                                }

                                if ( ribbon < 2 )
                                {
                                    plcMsg.ribbon = "3";
                                }

                                Type personType = plcMsg.GetType();

                                PropertyInfo[] properties = plcMsg.GetType().GetProperties();

                                 StringBuilder builder= new StringBuilder();
                                    for ( int j = 0; j < properties.Length-1; j++ )
                                    {
                                    builder.Append(properties[ j ].Name + ":" + properties[ j ].GetValue(plcMsg)+",");  
                                    }
                                builder.Append(properties[ properties.Length-1 ].Name + ":" + properties[ properties.Length - 1 ].GetValue(plcMsg));

                                string sss=builder.ToString();
                                TCPServer.clientList[ 0 ].SendMessage(builder.ToString());
                                LogHelper.Info(sss);
                                break;
                            }
                        }

                        if ( str == "未连接" )
                        {
                            tcpTrigger.TcpServerStop();
                            return false;
                        }
                        if ( str == "未收到数据" && !isagain )
                        {
                            isagain = false;
                            LogHelper.Info(str);
                            SendNg();
                            return false;
                        }
                    }


                    Res_write = str;
                    BackgroundColor = Brushes.Green;                    
                }
                else 
                {
                    BackgroundColor = Brushes.Red;
                }
            }
            catch 
            {
                BackgroundColor = Brushes.Red;
            }


            return true;
        }

        public void SendNetCmd(Socket internetSocket, string cmd)
        {
                SendVarData(internetSocket, Encoding.UTF8.GetBytes("fun"));
                SendVarData(internetSocket, Encoding.UTF8.GetBytes(cmd)); 
        }
        public int SendVarData(Socket s, byte[] data)
        {
 
            if ( s == null )
                return -1;
            string datas = "";
            try
            {
                int total = 0;
                int size = data.Length;
                int dataleft = size;
                int sent;
                byte[] datasize = new byte[4];
                datasize = BitConverter.GetBytes(size);
                sent = s.Send(datasize);
                datas = "";
                while ( total < size )
                {
                    sent = s.Send(data, total, dataleft, SocketFlags.None);
                    total += sent;
                    dataleft -= sent;
                }
                
                return total;
            }
            catch
            {
               
                return -1;
            }
        }

        public bool GetMessage() 
        {
            string  str;
            SendNetCmd(client.socket, "22");
            SendNetCmd(client.socket, "25");
       
            while ( true )
            {
                str = client.ReceiveVarData(client.socket);

                if ( str != "未收到数据" && str != "未连接" )
                {

                    if ( str == "fun" )
                    {
                        LogHelper.Info(str);
                        break;
                    }
                }

                if ( str == "未连接" )
                {
                   
                    return false;
                }
                if ( str == "未收到数据" )
                {
                    return false;
                }
            }

            while ( true )
            {
                str = client.ReceiveVarData(client.socket);

                if ( str != "未收到数据" && str != "未连接" )
                {

                    if ( str == "25" )
                    {
                        LogHelper.Info(str);
                        break;
                    }
                }
                if ( str == "未连接" )
                {
                    
                    return false;
                }
                if ( str == "未收到数据" )
                {
                    return false;
                }
            }
            int again=0;
            while ( true )
            {
                str = client.ReceiveVarData(client.socket);

                if ( str != "未收到数据" && str != "未连接" )
                {

                    if ( str.Contains("OKhp") )
                    {
                        string []strs=str.Split(',');
                        PlcMsg plcMsg = new PlcMsg();
                        if ( strs[ 4 ] == "0" )
                        {
                            plcMsg.printer = "0";
                        }
                        else
                        {
                            plcMsg.printer = "1";
                        }
                        if ( strs[ 5 ] == "0" )
                        {
                            if( again !=0)
                            Thread.Sleep(1000);
                            SendNetCmd(client.socket, "25");
                            again++;
                            if ( again < 3 ) 
                            {
                                continue;
                            }
                            plcMsg.printer = "1";
                        }
                        else
                        {
                            plcMsg.printer = "0";
                        }
                       
                        int ribbon=Convert.ToInt32(strs[ 29 ]);
                        if ( ribbon > 30 )
                        {
                            plcMsg.ribbon = "0";
                        }
                        if ( ribbon < 30 )
                        {
                            plcMsg.ribbon = "2";
                        }

                        if ( ribbon < 2 )
                        {
                            plcMsg.ribbon = "3";
                        }

                        Type personType = plcMsg.GetType();

                        PropertyInfo[] properties = plcMsg.GetType().GetProperties();

                        StringBuilder builder= new StringBuilder();
                        for ( int j = 0; j < properties.Length - 1; j++ )
                        {
                            builder.Append(properties[ j ].Name + ":" + properties[ j ].GetValue(plcMsg) + ",");
                        }
                        builder.Append(properties[ properties.Length - 1 ].Name + ":" + properties[ properties.Length - 1 ].GetValue(plcMsg));

                        string sss=builder.ToString();
                        TCPServer.clientList[ 0 ].SendMessage(builder.ToString());
                        LogHelper.Info(sss);
                        break;
                    }
                }

                if ( str == "未连接" )
                {
                    
                    return false;
                }
                if ( str == "未收到数据" )
                {
                    return false;
                }
            }


            return true;
        }

        public void SendNg() 
        {

            PlcMsg plcMsg = new PlcMsg();
           
            plcMsg.printer = "1";
           
            Type personType = plcMsg.GetType();

            PropertyInfo[] properties = plcMsg.GetType().GetProperties();

            StringBuilder builder= new StringBuilder();
            for ( int j = 0; j < properties.Length - 1; j++ )
            {
                builder.Append(properties[ j ].Name + ":" + properties[ j ].GetValue(plcMsg) + ",");
            }
            builder.Append(properties[ properties.Length - 1 ].Name + ":" + properties[ properties.Length - 1 ].GetValue(plcMsg));

            string sss=builder.ToString();
            TCPServer.clientList[ 0 ].SendMessage(builder.ToString());
            LogHelper.Info(sss);

        }
        public bool GetConnect()
        {
            Thread.Sleep(20);
            string  str;
            client.socket.SendTimeout = 100;
            SendNetCmd(client.socket, "25");

            while ( true )
            {
                client.socket.ReceiveTimeout = 100;
                str = client.ReceiveVarData(client.socket);

                if ( str != "未收到数据" && str != "未连接" )
                {

                    if ( str == "fun" )
                    {
                        
                        break;
                    }
                }

                if ( str == "未连接" )
                {

                    return false;
                }
                if ( str == "未收到数据" )
                {
                    return false;
                }
            }

            while ( true )
            {
                str = client.ReceiveVarData(client.socket);

                if ( str != "未收到数据" && str != "未连接" )
                {

                    if ( str == "25" )
                    {
                        
                        break;
                    }
                }
                if ( str == "未连接" )
                {

                    return false;
                }
                if ( str == "未收到数据" )
                {
                    return false;
                }
            }
            int again=0;
            while ( true )
            {
                str = client.ReceiveVarData(client.socket);

                if ( str != "未收到数据" && str != "未连接" )
                {

                    if ( str.Contains("OKhp") )
                    {
                        
                        break;
                    }
                }

                if ( str == "未连接" )
                {

                    return false;
                }
                if ( str == "未收到数据" )
                {
                    return false;
                }
            }

            Thread.Sleep(20);
            return true;
        }
        public string MsgSplit(string str)
        {

            List<string> builder = new List<string>();
            try
            {



                str = str.Trim();
                string[] strs = str.Split(';');

                MesMsg msg = new MesMsg();

                Type personType = msg.GetType();

                PropertyInfo[] properties = msg.GetType().GetProperties();

                for (int i = 0; i < strs.Length; i++)
                {
                    for (int j = 0; j < properties.Length; j++)
                    {
                        if (strs[i].Split(':')[0] == properties[j].Name)
                        {
                            properties[j].SetValue(msg, strs[i].Split(':')[1]);
                            break;
                        }
                    }
                }


                builder.Add(msg.taskid);
                builder.Add(msg.client_name);
                builder.Add(msg.datetime);
                builder.Add(msg.phone);
                string[] items = msg.items.Split(']');
                string amount = "";
                for (int i = 0; i < items.Length; i++)
                {
                    if (items[i].Length == 0) continue;
                    int startindex = items[i].IndexOf("<") + 1;
                    int stopindex = items[i].IndexOf(">") - startindex;
                    amount = items[i].Substring(startindex, stopindex);
                    items[i] = items[i].Substring(items[i].IndexOf(">")+1);
                    startindex = items[i].IndexOf("<") + 1;
                    stopindex = items[i].IndexOf(">") - startindex;
                    string currcycode = items[0].Substring(startindex, stopindex);
                    //items:[amount<300>currcycode<USD>itdetail<100 | 1,50 | 4 >][...];
                    items[i] = items[i].Substring(items[i].IndexOf(">")+1);
                    string[] itdetail = items[i].Split(',');

                    for (int j = 0; j < itdetail.Length; j++)
                    {
                        builder.Add(currcycode);
                        startindex = itdetail[j].IndexOf("<")+1;
                        stopindex = itdetail[j].IndexOf("|") - startindex;
                        builder.Add(itdetail[j].Substring(startindex, stopindex));
                        int num = Convert.ToInt32(itdetail[j].Substring(startindex, stopindex));

                        startindex = itdetail[j].IndexOf("|")+1;
                        stopindex = itdetail[j].IndexOf(">") ;
                        if (stopindex == -1)
                        {

                            builder.Add(itdetail[j].Substring(startindex));
                            int count = Convert.ToInt32(itdetail[j].Substring(startindex));
                            builder.Add((num * count).ToString());
                        }
                        else 
                        {

                            builder.Add(itdetail[j].Substring(startindex, stopindex - startindex));
                            int count = Convert.ToInt32(itdetail[j].Substring(startindex, stopindex - startindex));
                            builder.Add((num * count).ToString());
                        }
                      

                    }
                }
                builder.Add(amount);
                builder.Add(msg.recv_date);
                builder.Add(msg.deal_name);
                builder.Add(msg.taskid);
                builder.Add(msg.dep_name);
            }
            catch
            {
                return "Err";
            }


            return string.Join(":|:", builder);
        }

    }
}
