﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Toolkit.Log4;

namespace Toolkit
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            //ToolItems.Items.Add();
            this.Closing += MainWindow_Closing;

            Task.Run(() =>
            {
                string[] strs = new string[2];
                while (true)
                {
                    if (LogHelper.logQueue.Count > 0)
                    {
                        if (LogHelper.logQueue.TryDequeue(out strs))
                        {
                            this.Dispatcher.Invoke( new Action(() => { LogShow.AppendText(strs[0] + "  " + strs[1]+"\n"); }), null);

                            this.Dispatcher.Invoke(new Action(() => { LogShow.ScrollToEnd(); }), null);
                        }
                    }
                    if ( LogHelper.logQueue.Count > 100 ) 
                    {
                        LogHelper.logQueue = new System.Collections.Concurrent.ConcurrentQueue<string[]>();
                    }
                        Thread.Sleep(200);
                   
                }

            });
        }

        private void MainWindow_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            Environment.Exit(0);
        }
    }
}
